#ifdef ZDOOM_GL

//#define __DOOMTYPE__

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <windows.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "gl_struct.h"
#include "gl_mem.h"
#include "md2.h"

#ifndef GL_HEXEN
#include "doomdef.h"
#else
#include "h2def.h"
#endif
#include "r_local.h"
#include "p_spec.h"

extern int *g_a_iTexMD2;
extern int g_iModel,g_iTex;

#include "I_system.h"
#include "p_local.h"

EXTERN_CVAR (g_bMD2)
#define g_bMD2Interpol g_bMD2.value
GLTexture *p_stMD2Tex;
int STACK_ARGS ConPrintf (const char *format, ...);
#define printf ConPrintf

bool g_bNoMD2=false;

//#ifdef DOOM_GL
#if 1
//#define NB_MD2 6	// in md2.h
extern float *fMD2Scale;
//#define NUMMD2STATES (NUMSTATES/2)
#define NUMMD2STATES NUMSTATES
char **MD2_FileName;
char **MD2_WFileName;
float *fMD2offset;
md2_model_t **Models;
md2_model_t **WModels;
MD2StateTable GlobalMD2Table[NUMMD2STATES];
md2_model_t *SkyModel[3];
#endif	// DOOM_GL

//void GL_vSetTics(mobj_t *mobj,MD2enum_t md2)
void GL_vSetTics(mobj_t *mobj,int md2)
{
//#ifdef DOOM_GL
//#if defined(DOOM_GL) || defined(GL_HEXEN)
//	mobj->tics=GlobalMD2Table->iNbTics;
	mobj->MD2tics=GlobalMD2Table[md2].iNbTics;
//#endif
}

void GL_vSetWTics(pspdef_t*	psp,int md2)
{
	psp->MD2tics=GlobalMD2Table[md2].iNbTics;
}

extern float cosA,sinA,xC,yC,zC/*,LightLev*/;	// MR3006

void _md2_drawModel (md2_model_t *model, int frame,float fRed,float fGreen,float fBlue,GLfloat fAlpha);
void _md2_drawModelg (md2_model_t *model, int frame,float fRed,float fGreen,float fBlue,GLfloat fAlpha);
void _md2_drawModelgi (md2_model_t *model, int frame1, int frame2, float pol,float fRed,float fGreen,float fBlue,GLfloat fAlpha);
void (*GL_vDrawMD2)(mobj_t *pSpr,float fRed,float fGreen,float fBlue);

EXTERN_CVAR (usecoronas)
#define usecoronas usecoronas.value

void GL_AddCorona(int doomednum,float x,float y,float z,float fLightLevel);

void GL_vDrawMD2g(mobj_t *pSpr,float fRed,float fGreen,float fBlue)
{ float xi,yi,zi,angle,fAlpha;
  int iFrame;
  md2_model_t *model,*wmodel;
  int iCoronaIdx;

//#ifdef DOOM_GL
//#if defined(DOOM_GL) || defined(GL_HEXEN)
	model=Models[GlobalMD2Table[pSpr->state->MD2].iMD2];
	wmodel=WModels[GlobalMD2Table[pSpr->state->MD2].iMD2];
	if (pSpr->MD2tics<0)	// anti-bug...
		pSpr->MD2tics=0;
	/*iFrame=GlobalMD2Table[pSpr->state->MD2].iFirstFrame+
		(int)((float)(GlobalMD2Table[pSpr->state->MD2].iNbTics-pSpr->MD2tics)*
			  (float)(GlobalMD2Table[pSpr->state->MD2].iLastFrame-GlobalMD2Table[pSpr->state->MD2].iFirstFrame)/(float)GlobalMD2Table[pSpr->state->MD2].iNbTics);*/
	iFrame=GlobalMD2Table[pSpr->state->MD2].iFirstFrame+
		(int)((float)(GlobalMD2Table[pSpr->state->MD2].iNbTics-pSpr->MD2tics)*GlobalMD2Table[pSpr->state->MD2].fFrameTicFactor);
	xi=-(float)pSpr->x/MAP_SCALE;
	//yi=((float)pSpr->z/*+(float)spritetopoffset[lump]*/)/MAP_SCALE/*+(float)3/(MAP_SCALE>>FRACBITS)*/;	// Why +2 ???
	//yi=(float)pSpr->z/MAP_SCALE+23.0f/MAP_COEFF;
	yi=(float)pSpr->z/MAP_SCALE+fMD2offset[GlobalMD2Table[pSpr->state->MD2].iMD2]/MAP_COEFF;	// 18
	zi=(float)pSpr->y/MAP_SCALE;

	angle=-180.0f+(float)(pSpr->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(xi,yi,zi);
	glRotatef(angle,0.0f,1.0f,0.0f);

	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[GlobalMD2Table[pSpr->state->MD2].iMD2]);

	if(pSpr->flags&MF_SHADOW)
		//GL_StaticLight4f(fLightLevel,fLightLevel,fLightLevel,0.5f);
		fAlpha=0.5f;
	else
		//GL_StaticLight3f(fLightLevel,fLightLevel,fLightLevel);
		fAlpha=1.0f;

	// MR3006: DynLight
	cosA=(float)cos(angle);
	sinA=(float)sin(angle);
	xC=xi;
	yC=yi;
	zC=zi;
	//LightLev=fLightLevel;
	glCullFace(GL_FRONT);
	glAlphaFunc(GL_NOTEQUAL,0.0f);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	_md2_drawModelg (model, iFrame,fRed,fGreen,fBlue,fAlpha);
	//_md2_drawModel (model, iFrame,fRed,fGreen,fBlue,fAlpha);
	if (wmodel)
	{	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[GlobalMD2Table[pSpr->state->MD2].iMD2]+1);
		_md2_drawModelg (wmodel, iFrame,fRed,fGreen,fBlue,fAlpha);
	}
	glCullFace(GL_BACK);
	glDisable(GL_BLEND);

	glPopMatrix();
//#endif
	if (usecoronas&&((iCoronaIdx=GL_GenerateCorona(pSpr->type))!=-1))	// MR2007
	{ player_t *player;

		player=&players[consoleplayer];
		if (P_CheckSight(player->mo,pSpr))
		//while (GL_iGetDoomednum(iCoronaIdx)==pSpr->info->doomednum)
		while (GL_iGetType(iCoronaIdx)==pSpr->type)
		{	
			if (GL_ChechCoronaInSight(iCoronaIdx,player->mo,pSpr))
				GL_AddCorona(iCoronaIdx,xi,(float)pSpr->z/MAP_SCALE,zi,1.0f);	// ??? why fLightLevel with coronas ???
			iCoronaIdx++;
		}
	}
}

void GL_vDrawMD2i(mobj_t *pSpr,float fRed,float fGreen,float fBlue)
{ float xi,yi,zi,angle,fAlpha;
  int iFrame1,iFrame2;
  float fFrame1,fPol;
  md2_model_t *model,*wmodel;
  int iCoronaIdx;

//#ifdef DOOM_GL  frac
//#if defined(DOOM_GL) || defined(GL_HEXEN)
	model=Models[GlobalMD2Table[pSpr->state->MD2].iMD2];
	wmodel=WModels[GlobalMD2Table[pSpr->state->MD2].iMD2];
	if (pSpr->MD2tics<0)	// anti-bug...
		pSpr->MD2tics=0;
	/*iFrame=GlobalMD2Table[pSpr->state->MD2].iFirstFrame+
		(int)((float)(GlobalMD2Table[pSpr->state->MD2].iNbTics-pSpr->MD2tics)*
			  (float)(GlobalMD2Table[pSpr->state->MD2].iLastFrame-GlobalMD2Table[pSpr->state->MD2].iFirstFrame)/(float)GlobalMD2Table[pSpr->state->MD2].iNbTics);*/


	fFrame1=GlobalMD2Table[pSpr->state->MD2].iFirstFrame+
		((float)(GlobalMD2Table[pSpr->state->MD2].iNbTics-pSpr->MD2tics)*GlobalMD2Table[pSpr->state->MD2].fFrameTicFactor);
	iFrame1=(int)floor(fFrame1);
	iFrame2=iFrame1+1;
	//if (iFrame2>GlobalMD2Table[pSpr->state->MD2].iLastFrame)
	if (GlobalMD2Table[pSpr->state->MD2].iNbTics==1)
	{	fPol=0.0f;
		iFrame2=iFrame1;
	}
	else
		fPol=1.0f-(float)iFrame2+fFrame1;


	xi=-(float)pSpr->x/MAP_SCALE;
	//yi=((float)pSpr->z/*+(float)spritetopoffset[lump]*/)/MAP_SCALE/*+(float)3/(MAP_SCALE>>FRACBITS)*/;	// Why +2 ???
	//yi=(float)pSpr->z/MAP_SCALE+23.0f/MAP_COEFF;
	yi=(float)pSpr->z/MAP_SCALE+fMD2offset[GlobalMD2Table[pSpr->state->MD2].iMD2]/MAP_COEFF;	// 18
	zi=(float)pSpr->y/MAP_SCALE;

	angle=-180.0f+(float)(pSpr->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(xi,yi,zi);
	glRotatef(angle,0.0f,1.0f,0.0f);

	//glBindTexture(GL_TEXTURE_2D,50000+GlobalMD2Table[pSpr->state->MD2].iMD2);
	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[GlobalMD2Table[pSpr->state->MD2].iMD2]);

	if(pSpr->flags&MF_SHADOW)
		//GL_StaticLight4f(fLightLevel,fLightLevel,fLightLevel,0.5f);
		fAlpha=0.5f;
	else
		//GL_StaticLight3f(fLightLevel,fLightLevel,fLightLevel);
		fAlpha=1.0f;

	// MR3006: DynLight
	cosA=(float)cos(angle);
	sinA=(float)sin(angle);
	xC=xi;
	yC=yi;
	zC=zi;
	//LightLev=fLightLevel;
	glCullFace(GL_FRONT);
	glAlphaFunc(GL_NOTEQUAL,0.0f);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	_md2_drawModelgi (model, iFrame1,iFrame2, fPol,fRed,fGreen,fBlue,fAlpha);
	if (wmodel)
	{	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[GlobalMD2Table[pSpr->state->MD2].iMD2]+1);
		_md2_drawModelgi (wmodel, iFrame1,iFrame2, fPol,fRed,fGreen,fBlue,fAlpha);
	}
	//_md2_drawModel (model, iFrame,fLightLevel,fAlpha);
	//_md2_drawModel (wmodel, iFrame,fLightLevel,fAlpha);
	glCullFace(GL_BACK);
	glDisable(GL_BLEND);

	glPopMatrix();
//#endif
	if (usecoronas&&((iCoronaIdx=GL_GenerateCorona(pSpr->type))!=-1))	// MR2007
	{ player_t *player;

		player=&players[consoleplayer];
		if (P_CheckSight(player->mo,pSpr))
		//while (GL_iGetDoomednum(iCoronaIdx)==pSpr->info->doomednum)
		while (GL_iGetType(iCoronaIdx)==pSpr->type)
		{	
			if (GL_ChechCoronaInSight(iCoronaIdx,player->mo,pSpr))
				GL_AddCorona(iCoronaIdx,xi,(float)pSpr->z/MAP_SCALE,zi,1.0f);	// ??? why fLightLevel with coronas ???
			iCoronaIdx++;
		}
	}
}

#define WEAPONBOTTOM			128*FRACUNIT
#define WEAPONTOP				(32*FRACUNIT+0x6000)
void GL_vDrawMD2Weapon(state_t *pState,float fRed,float fGreen,float fBlue)
{ float xi,yi,zi,angle,fAlpha;
  int iFrame1;
  md2_model_t *model;
  mobj_t *pSpr;

	glClearDepth(1.0);
	glClear(GL_DEPTH_BUFFER_BIT);
	
	pSpr=players[displayplayer].mo;
	model=Models[GlobalMD2Table[pState->MD2].iMD2];
/*	if (pSpr->MD2tics<0)	// anti-bug...
		pSpr->MD2tics=0;*/

/*	fFrame1=GlobalMD2Table[pState->MD2].iFirstFrame+
		((float)(GlobalMD2Table[pState->MD2].iNbTics-players[displayplayer].psprites[0].MD2tics)*GlobalMD2Table[pState->MD2].fFrameTicFactor);
	iFrame1=(int)floor(fFrame1);
	iFrame2=iFrame1+1;
	if (GlobalMD2Table[pState->MD2].iNbTics==1)
	{	fPol=0.0f;
		iFrame2=iFrame1;
	}
	else
		fPol=1.0f-(float)iFrame2+fFrame1;*/
	iFrame1=GlobalMD2Table[pState->MD2].iFirstFrame+
	(int)((float)(GlobalMD2Table[pState->MD2].iNbTics-players[displayplayer].psprites[0].MD2tics)*GlobalMD2Table[pState->MD2].fFrameTicFactor);


	xi=-(float)pSpr->x/MAP_SCALE;
	yi=(float)pSpr->z/MAP_SCALE+fMD2offset[GlobalMD2Table[pState->MD2].iMD2]/MAP_COEFF+(float)(WEAPONTOP-players[displayplayer].psprites[0].sy)/MAP_SCALE;
	zi=(float)pSpr->y/MAP_SCALE;

	angle=-180.0f+(float)(pSpr->angle>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(xi,yi,zi);
	glRotatef(angle,0.0f,1.0f,0.0f);
	angle=(float)(pSpr->pitch>>ANGLETOFINESHIFT)*360.0f/FINEANGLES;
	glRotatef(-angle,   0.0f, 0.0f, 1.0f);
	
	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[GlobalMD2Table[pState->MD2].iMD2]);

	if(pSpr->flags&MF_SHADOW)
		fAlpha=0.5f;
	else
		fAlpha=1.0f;

	cosA=(float)cos(angle);
	sinA=(float)sin(angle);
	xC=xi;
	yC=yi;
	zC=zi;
	glCullFace(GL_FRONT);
	glAlphaFunc(GL_NOTEQUAL,0.0f);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//_md2_drawModelgi (model, iFrame1,iFrame2, fPol,fRed,fGreen,fBlue,fAlpha);
	_md2_drawModelg (model, iFrame1,fRed,fGreen,fBlue,fAlpha);
	glCullFace(GL_BACK);
	glDisable(GL_BLEND);

	glPopMatrix();
}

void md2_getAnimationFramesFromName (md2_model_t *model, char *animName, int *startFrame, int *endFrame)
{
	int i, j, pos;
	int count, numFrames, frameCount;
	int lastId;
	char name[16];

	/*strcpy (last, model->frames[0].name);
	pos = strlen (last) - 1;
	j = 0;
	while (last[pos] >= '0' && last[pos] <= '9' && j < 2)
	{
		pos--;
		j++;
	}
	last[pos + 1] = '\0';*/

	lastId = 0;
	count = 0;
	numFrames = 0;
	frameCount = 0;

	for (i = 0; i <= model->header.numFrames; i++)
	{
		if (i == model->header.numFrames)
			strcpy (name, ""); // some kind of a sentinel
		else
			strcpy (name, model->frames[i].name);
		pos = strlen (name) - 1;
		j = 0;
		while (name[pos] >= '0' && name[pos] <= '9' && j < 2)
		{
			pos--;
			j++;
		}
		name[pos + 1] = '\0';

		if (!lastId&&!stricmp (animName, name))
		{
			lastId=1;

			*startFrame = i;
		}
		if (lastId&&stricmp (animName, name))
		{
			*endFrame = i - 1;
			return;
		}
	}

	*startFrame = *endFrame = 0;
}


//#define C_sz_MD2ini0	"md2.ini"
char C_sz_MD2ini0[255]="md2.ini";
int iModel=0,iCorresp=0,g_iNbMD2=0;
static int iState=0;
char C_sz_MD2ini[255];

typedef struct
{	char szState[64];
	int iState;
} tdstLkTable;

static tdstLkTable *LkTable;

void fn_vReadStateSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer2=NULL;

	if (g_bNoMD2)
		return;
	strcpy(LkTable[iState].szState,buffer);
	LkTable[iState].iState=iState;

	GlobalMD2Table[iState].iMD2=iModel;
	GetPrivateProfileString(buffer,"anim","-",szBuffer,1024,C_sz_MD2ini);
	strcpy(GlobalMD2Table[iState].name,szBuffer);
	GetPrivateProfileString(buffer,"NbTics","0",szBuffer,1024,C_sz_MD2ini);
	GlobalMD2Table[iState].iNbTics=atoi(szBuffer);
	GetPrivateProfileString(buffer,"StartFrame","0",szBuffer,1024,C_sz_MD2ini);
	GlobalMD2Table[iState].iFirstFrame=atoi(szBuffer);
	GetPrivateProfileString(buffer,"EndFrame","0",szBuffer,1024,C_sz_MD2ini);
	GlobalMD2Table[iState].iLastFrame=atoi(szBuffer);
	iState++;
}

void fn_vReadModelSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer,*p_cBuffer2=NULL;

	if (g_bNoMD2)
		return;
	GetPrivateProfileString(buffer,"file","-",szBuffer,1024,C_sz_MD2ini);
	if (szBuffer[0]=='-')
		return;
	MD2_FileName[iModel]=(char *)malloc(strlen(szBuffer)+1);
	strcpy(MD2_FileName[iModel],szBuffer);
	GetPrivateProfileString(buffer,"weapon","-",szBuffer,1024,C_sz_MD2ini);
	MD2_WFileName[iModel]=(char *)malloc(strlen(szBuffer)+1);
	strcpy(MD2_WFileName[iModel],szBuffer);
	GetPrivateProfileString(buffer,"offset","0.0",szBuffer,1024,C_sz_MD2ini);
	fMD2offset[iModel]=(float)atof(szBuffer);
	GetPrivateProfileString(buffer,"scale","0.0",szBuffer,1024,C_sz_MD2ini);
	fMD2Scale[iModel]=(float)atof(szBuffer)*(float)MAP_COEFF/100.0f/*/10.0f*/;
	GetPrivateProfileString(buffer,"states","-",szBuffer,1024,C_sz_MD2ini);
	p_cBuffer=szBuffer;
	//while (*p_cBuffer!=0)
	while (1)
	{	p_cBuffer2=strpbrk(p_cBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		fn_vReadStateSection(p_cBuffer);
		if (p_cBuffer2)
			p_cBuffer=p_cBuffer2+1;
		else
			break;
	}
	iModel++;
}

int fn_iGetMD2State(char *szState)
{ int i;

	for (i=0;i<iState;i++)
		if (!strcmp(LkTable[i].szState,szState))
			return i;
	return -1;
}

void fn_vReadCorrespSection(char *buffer)
{ char szBuffer[1024],*p_cBuffer2=NULL;

	if (g_bNoMD2)
		return;
	GetPrivateProfileString("CORRESP",buffer,"-",szBuffer,1024,C_sz_MD2ini);
	//CorrespMD2Table[iCorresp].sprite=iCorresp;
	if (szBuffer[0]!='-')
	{	/*CorrespMD2Table[iCorresp].md2=fn_iGetMD2State(szBuffer);
		if (CorrespMD2Table[iCorresp].md2==-1)
			printf("Warning: szBuffer state undefined\n");*/
		p_cBuffer2=strpbrk(szBuffer," ");
		if (p_cBuffer2)
			p_cBuffer2[0]=0;
		states[iCorresp+1].MD2=fn_iGetMD2State(szBuffer);
		if (states[iCorresp+1].MD2==-1)
			printf("Warning: MD2: %s state undefined\n",szBuffer);
		if (p_cBuffer2)
			states[iCorresp+1].tics=atoi(p_cBuffer2+1);
	}
	else
		states[iCorresp+1].MD2=-1;
	iCorresp++;
}

void MD2_vReadMD2ini()
{ char szBuffer[40000],*p_cBuffer;
  int i;

/*#ifndef ZDOOM_GL
	if (!g_bMD2)
#else
	if (!g_bMD2.value)
#endif
		return;*/

	if (g_bNoMD2)
		return;
	if (g_bMD2Interpol==2)
		GL_vDrawMD2=GL_vDrawMD2i;
	else
		GL_vDrawMD2=GL_vDrawMD2g;

	GetCurrentDirectory(255,C_sz_MD2ini);
	strcat(C_sz_MD2ini,"\\");
	strcat(C_sz_MD2ini,C_sz_MD2ini0);

	LkTable=(tdstLkTable *)malloc(NUMMD2STATES*sizeof(tdstLkTable));
	
	GetPrivateProfileString("MD2","Nb","0",szBuffer,1024,C_sz_MD2ini);
	g_iNbMD2=atoi(szBuffer);
	g_a_iTexMD2=(int *)malloc((g_iNbMD2+3)*sizeof(int));	// +3 coz of MD2 skies
	MD2_FileName=(char **)malloc(g_iNbMD2*sizeof(char *));
	MD2_WFileName=(char **)malloc(g_iNbMD2*sizeof(char *));
	p_stMD2Tex=(GLTexture *)malloc(2*g_iNbMD2*sizeof(GLTexture));
	fMD2offset=(float *)malloc(g_iNbMD2*sizeof(float));
	fMD2Scale=(float *)malloc((g_iNbMD2+3)*sizeof(float));		// +3 coz of MD2 skies
	Models=(md2_model_t **)malloc(g_iNbMD2*sizeof(md2_model_t *));
	WModels=(md2_model_t **)malloc(g_iNbMD2*sizeof(md2_model_t *));
	for (i=0;i<g_iNbMD2;i++)
	{	Models[i]=(md2_model_t *)malloc(g_iNbMD2*sizeof(md2_model_t));
		WModels[i]=(md2_model_t *)malloc(g_iNbMD2*sizeof(md2_model_t));
	}
	
	GetPrivateProfileString("MD2",NULL,"-",szBuffer,4096,C_sz_MD2ini);
	p_cBuffer=szBuffer;
	p_cBuffer+=strlen(p_cBuffer)+1;
	while (*p_cBuffer!=0)
	{
		fn_vReadModelSection(p_cBuffer);
		p_cBuffer+=strlen(p_cBuffer)+1;
	}

	GetPrivateProfileString("CORRESP",NULL,"-",szBuffer,40000,C_sz_MD2ini);
	p_cBuffer=szBuffer;
	p_cBuffer+=strlen(p_cBuffer)+1;
	while (*p_cBuffer!=0)
	{
		fn_vReadCorrespSection(p_cBuffer);
		p_cBuffer+=strlen(p_cBuffer)+1;
	}

	free(LkTable);
}

void GL_vInitMD2Tables()
{ int i,j;
  md2_model_t *model;

	printf("OpenGL: Init MD2\n");

	for (j=0;j<NUMSTATES;j++)
		states[j].MD2=-1;

	MD2_vReadMD2ini();

	if (g_bNoMD2)
		return;

	for (i=0;i<g_iNbMD2;i++)
	{	Models[i]=NULL;
		WModels[i]=NULL;
	}
	/*for (j=0;j<NB_CORRESP_STATES;j++)
		states[CorrespMD2Table[j].sprite].MD2=CorrespMD2Table[j].md2;*/

	for (i=0;i<iState;i++)
	{	if (!Models[GlobalMD2Table[i].iMD2])
		{	Models[GlobalMD2Table[i].iMD2]=md2_readModel(MD2_FileName[GlobalMD2Table[i].iMD2]);
			g_a_iTexMD2[g_iModel]=g_iTex-1;
			WModels[GlobalMD2Table[i].iMD2]=md2_readModel(MD2_WFileName[GlobalMD2Table[i].iMD2]);
			g_iModel++;
			if (Models[GlobalMD2Table[i].iMD2]==NULL)
				I_Error("Can't find %s\n",MD2_FileName[GlobalMD2Table[i].iMD2]);
		}
		model=Models[GlobalMD2Table[i].iMD2];
		if (GlobalMD2Table[i].iFirstFrame)
			continue;
		md2_getAnimationFramesFromName(model,GlobalMD2Table[i].name,&GlobalMD2Table[i].iFirstFrame,&GlobalMD2Table[i].iLastFrame);
		GlobalMD2Table[i].iNbTics=0;
		for (j=0;j<NUMSTATES;j++)
			if ((states[j].MD2==i)&&(states[j].tics!=-1))
				GlobalMD2Table[i].iNbTics+=states[j].tics;
		
		GlobalMD2Table[i].fFrameTicFactor=(float)(GlobalMD2Table[i].iLastFrame-GlobalMD2Table[i].iFirstFrame)/(float)GlobalMD2Table[i].iNbTics;
	}

	fMD2Scale[g_iModel]=1.0f;
	SkyModel[0]=md2_readModel("md2\\sky.md2");
	g_a_iTexMD2[g_iModel]=g_iTex-1;
	g_iModel++;
	fMD2Scale[g_iModel]=1.0f;
	SkyModel[1]=md2_readModel("md2\\sky2.md2");
	g_a_iTexMD2[g_iModel]=g_iTex-1;
	g_iModel++;
	fMD2Scale[g_iModel]=1.0f;
	SkyModel[2]=md2_readModel("md2\\sky3.md2");
	g_a_iTexMD2[g_iModel]=g_iTex-1;
	g_iModel++;
}

#if 0
void old_GL_vInitMD2Tables()
{ int i,j;
  md2_model_t *model;

//#ifdef DOOM_GL
#if defined(DOOM_GL) || defined(GL_HEXEN)
	MD2_vReadMD2ini();
	for (i=0;i<NB_MD2;i++)
		Models[i]=NULL;
	for (j=0;j<NUMSTATES;j++)
		states[j].MD2=MD2_INVALID;
	for (j=0;j<NB_CORRESP_STATES;j++)
		states[CorrespMD2Table[j].sprite].MD2=CorrespMD2Table[j].md2;

	for (i=0;i<NB_MD2_STATES;i++)
	{	if (!Models[GlobalMD2Table[i].iMD2])
		{	Models[GlobalMD2Table[i].iMD2]=md2_readModel(MD2_FileName[GlobalMD2Table[i].iMD2]);
			if (Models[GlobalMD2Table[i].iMD2]==NULL)
				I_Error("Can't find %s\n",MD2_FileName[GlobalMD2Table[i].iMD2]);
		}
		model=Models[GlobalMD2Table[i].iMD2];
		if (GlobalMD2Table[i].iFirstFrame)
			continue;
		md2_getAnimationFramesFromName(model,GlobalMD2Table[i].name,&GlobalMD2Table[i].iFirstFrame,&GlobalMD2Table[i].iLastFrame);
		GlobalMD2Table[i].iNbTics=0;
		for (j=0;j<NB_CORRESP_STATES;j++)
			if ((CorrespMD2Table[j].md2==i)&&(states[CorrespMD2Table[j].sprite].tics!=-1))
				GlobalMD2Table[i].iNbTics+=states[CorrespMD2Table[j].sprite].tics;
	}
#endif
}
#endif	// 0

GLboolean MD2_bIsASprite(int sprite,int frame)
{ int s;

	if (!g_bMD2.value)
		return true;
	for (s=0;s<NUMSTATES;s++)
	{		if ((states[s].sprite==sprite)&&(states[s].frame==frame)&&(states[s].MD2==MD2_INVALID))
				return true;
	}
	return false;
}

extern GLSky *GLSky1;
extern int iAltitudeMin;
void GL_vDrawSkyMD2(int episode)
{  float yMapCenter;

	if (!SkyModel[episode])
		return;
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();

	yMapCenter=-50.0f*(GLfloat)iAltitudeMin/MAP_SCALE;
	glTranslatef(GLSky1->xMapCenter,yMapCenter,GLSky1->zMapCenter);

	glBindTexture(GL_TEXTURE_2D,50000+g_a_iTexMD2[g_iModel-3+episode]);

	glCullFace(GL_FRONT);
	glAlphaFunc(GL_NOTEQUAL,0.0f);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	_md2_drawModelg (SkyModel[episode], 0,1.0f,1.0f,1.0f,1.0f);
	glCullFace(GL_BACK);
	glDisable(GL_BLEND);

	glPopMatrix();
}
#endif	// ZDOOM_GL