#ifdef ZDOOM_GL

//#define __DOOMTYPE__

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "gl_struct.h"
#include "gl_mem.h"
#include "gl_priv.h"
#ifndef GL_HEXEN
#include "doomdef.h"
#else
#include "h2def.h"
#endif
#include "p_spec.h"

#include "gi.h"

extern  int *switchlist;
extern int  numswitches;
extern GLTexture *p_stMD2Tex;
extern int *g_a_iTexMD2;
extern int g_iTex;

extern GLboolean g_b3Dfx;

// Coronas...
extern unsigned char *g_p_bCoronaTexture;
extern int g_iCorona;
int g_iParticle;
extern unsigned char *g_p_bLightTexture;

// Flares
/*extern unsigned char *flareTex[6];
extern unsigned char *shineTex[10];
extern int g_iFlare[6];*/
extern int g_iShine[10];

// Wall impacts
extern unsigned char *g_p_bImpactTexture[7];
extern int g_iImpact[7];

extern int		firstflat, lastflat, numflats;
extern int		firstpatch, lastpatch, numpatches;
extern int		firstspritelump, lastspritelump, numspritelumps;

extern int			numtextures;

extern int		flatmemory, texturememory, spritememory;
extern texture_t	**textures;
extern byte *R_GetColumn (int tex, int col);
// sprites
extern GLTexture *p_stGLSprites;
extern int	iNbGLSprites;
extern GLTexArray *p_stGLSprArray;

// Fonts
extern GLTexture *p_stGLFontA;
extern int	iNbGLFontA;
extern GLTexture *p_stGLFontB;
extern int	iNbGLFontB;
GLuint *FontAobjs=NULL,*FontBobjs;

// textures animations
extern anim_t *anims;
extern anim_t *lastanim;


extern switchlist_t alphSwitchList[];
int *a_iGLTexTranslation;
int *glSwitchList;
#define MAXSWITCHES gameinfo.maxSwitch

GLTexture *p_stGLTextures;
int			iNbTexturesInMap,iNbGLTextures=0;
GLuint *texobjs;
GLuint *sprobjs;
GLTexArray *p_stGLTexArray;

byte *p_bPalette;
#ifdef PALETTED_TEXTURE
GLubyte p_bGLPalette[256][4];
GLfloat p_fAlpha[256];
GLfloat p_fRed[256],p_fGreen[256],p_fBlue[256];
#endif

int xS[512],yS[512];
int xD[512],yD[512];

GLboolean g_bPaletteTexture=FALSE;

#ifdef PALETTED_TEXTURE
  PROC glColorTableEXT2;
  int (WINAPI *glColorTableEXT)(GLenum enum1,GLenum enum2,GLsizei size,GLenum enum3,GLenum enum4,const GLvoid *data);
  PROC glGetColorTableParameterivEXT;
#endif

GLboolean g_bOnTheFly;
GLint GL_vRegisterFlatTextureOnTheFly(int iTexNum);

#ifdef MINIGL
int g_iTexId=0;
void GL_vGenTextures(int iNbTex,GLuint *a_iTex)
{ int i;

	for (i=0;i<iNbTex;i++)
		a_iTex[i]=g_iTexId++;
}
void GL_vDeleteTextures(int iNbTex,GLuint *a_iTex)
{
	if (a_iTex)
		g_iTexId=a_iTex[0];
}
void GL_vReinitTexId()
{
	g_iTexId=0;
}
#endif	// MINIGL

void fn_vStretchTexture(long lWidthS,long lHeightS,long lWidthD,long lHeightD)
{ int x,y;
  float fXRatio,fYRatio;

	fXRatio=(float)lWidthS/(float)lWidthD;
	fYRatio=(float)lHeightS/(float)lHeightD;
	for (y=0;y<lHeightD;y++)
	{
		yS[y]=(int)(fYRatio*(float)y);
	}	
	for (x=0;x<lWidthD;x++)
	{
		xS[x]=(int)(fXRatio*(float)x);
	}
	// MR2506
	for (y=0;y<lHeightS;y++)
	{
		yD[y]=(int)((float)y/fYRatio);
	}	
	for (x=0;x<lWidthS;x++)
	{
		xD[x]=(int)((float)x/fXRatio);
	}
}

void GL_vReinitTextures()	// After changing resolution
{ int i;

#ifdef MINIGL
	GL_vReinitTexId();
#endif	// MINIGL
#ifdef PALETTED_TEXTURE

	if (g_bPaletteTexture)
	{	for (i=0;i<256;i++)
		{	p_bGLPalette[i][0]=p_bPalette[3*i];
			p_bGLPalette[i][1]=p_bPalette[3*i+1];
			p_bGLPalette[i][2]=p_bPalette[3*i+2];
			p_fRed[i]=(float)p_bPalette[3*i]/255;
			p_fGreen[i]=(float)p_bPalette[3*i+1]/255;
			p_fBlue[i]=(float)p_bPalette[3*i+2]/255;
			if (i==205)
			{	p_bGLPalette[i][3]=0;
				p_fAlpha[i]=0.0f;
			}
			else
			{	p_bGLPalette[i][3]=255;
				p_fAlpha[i]=1.0f;
			}
		}

		glColorTableEXT2=wglGetProcAddress("glColorTableEXT");
		glColorTableEXT=(int (WINAPI *)(unsigned int,unsigned int,int,unsigned int,unsigned int,const void *))glColorTableEXT2;
		glGetColorTableParameterivEXT=wglGetProcAddress("glGetColorTableParameterivEXT");
	}
#endif	// PALETTED_TEXTURE

	// --------------- FONTS ----------------------
#ifndef MINIGL
	glGenTextures(iNbGLFontA,FontAobjs);
#else
	for (i=0;i<iNbGLFontA;i++)
		FontAobjs[i]=40000+i;
#endif
	for (i = 0; i < iNbGLFontA; i++) 
	{
		glBindTexture(GL_TEXTURE_2D, FontAobjs[i]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
//#ifdef BILINEAR
//		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
//		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
//#else
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//#endif
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

		glTexImage2D(GL_TEXTURE_2D, 0, 4, p_stGLFontA[i].iWidth, p_stGLFontA[i].iHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, p_stGLFontA[i].p_bRGBBuffer);
	}

// ------------------- MD2 ---------------------
	for (i=0;i<g_iTex;i++)
	{	glBindTexture (GL_TEXTURE_2D, 50000+i);
		glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		if (g_bPaletteTexture)
		{	glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, p_stMD2Tex[i].iWidth, p_stMD2Tex[i].iHeight, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_stMD2Tex[i].p_bRGBBuffer);
		}
		else
			glTexImage2D (GL_TEXTURE_2D, 0, GL_RGB, p_stMD2Tex[i].iWidth, p_stMD2Tex[i].iHeight, 0, GL_RGB, GL_UNSIGNED_BYTE, p_stMD2Tex[i].p_bRGBBuffer);		
	}

	// --------------- MAP TEXTURES ----------------------
	if (!iNbGLTextures)
		return;
	glGenTextures(iNbGLTextures,texobjs);
   
	for (i = 0; i < iNbGLTextures; i++) 
	{
		glBindTexture(GL_TEXTURE_2D, texobjs[i]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE /*GL_DECAL*/);

#ifdef PALETTED_TEXTURE
		if ((g_bPaletteTexture)&&(!p_stGLTextures[i].a_stSubTex[0].bIsNZ))
		{	glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, p_stGLTextures[i].iWidth, p_stGLTextures[i].iHeight, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_stGLTextures[i].p_bRGBBuffer);
		}
		else
#endif
		{	glTexImage2D(GL_TEXTURE_2D, 0, 4, p_stGLTextures[i].iWidth, p_stGLTextures[i].iHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, p_stGLTextures[i].p_bRGBBuffer);
		}
    }
	
	// --------------- SPRITES ----------------------
	glGenTextures(iNbGLSprites,sprobjs);
	for (i = 0; i < iNbGLSprites; i++) 
	{
		glBindTexture(GL_TEXTURE_2D, sprobjs[i]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

		glTexImage2D(GL_TEXTURE_2D, 0, 4, p_stGLSprites[i].iWidth, p_stGLSprites[i].iHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, p_stGLSprites[i].p_bRGBBuffer);
		
    }

// --------------- CORONASS ----------------------

	glGenTextures(1,(unsigned int *)&g_iCorona);

	glBindTexture(GL_TEXTURE_2D, g_iCorona);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	glTexImage2D(GL_TEXTURE_2D, 0, 4, 128, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bCoronaTexture);
	//glTexImage2D(GL_TEXTURE_2D, 0, 4, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bCoronaTexture);
// Light
	glGenTextures(1,(unsigned int *)&g_iParticle);
	glBindTexture(GL_TEXTURE_2D, g_iParticle);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	//glTexImage2D(GL_TEXTURE_2D, 0, 4, 128, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bLightTexture);
	glTexImage2D(GL_TEXTURE_2D, 0, 4, 8, 8, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bLightTexture);

#ifdef FLARES
// Flares
/*for (i = 0; i < 6; i++) 
	{
	iNbGLSprites++;
	g_iFlare[i] = sprobjs[iNbGLSprites-1]+50+i+2;
	
    glBindTexture(GL_TEXTURE_2D, g_iFlare[i]);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minFilter);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, maxFilter);
    
	sprintf(filename, "Flare%d.BW", i+1);
	
	buf = load_luminance(filename, &width, &height, &components);
    gluBuild2DMipmaps(GL_TEXTURE_2D, 1, width, height, GL_LUMINANCE, GL_UNSIGNED_BYTE, buf);
    
	free(buf);

	//printf("DEBG - SET: g_iFlare %d\n", i);
	}*/

	
	glGenTextures(10,g_iShine);
for (i = 0; i < 10; i++) 
  {
    iNbGLSprites++;

	glBindTexture(GL_TEXTURE_2D, g_iShine[i]);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minFilter);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, maxFilter);
    
	sprintf(filename, "Shine%d.BW", i);

	buf = load_luminance(filename, &width, &height, &components);
    gluBuild2DMipmaps(GL_TEXTURE_2D, 1, width, height, GL_LUMINANCE, GL_UNSIGNED_BYTE, buf);
    
	free(buf);

  }
#endif
// --------------- DECALS ----------------------
	glGenTextures(7,(unsigned int *)g_iImpact);

	for (i=0;i<7;i++)
	{	glBindTexture(GL_TEXTURE_2D, g_iImpact[i]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

		if (i==0)
			glTexImage2D(GL_TEXTURE_2D, 0, 4, 32, 32, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bImpactTexture[i]);
		else
		if (i<3)
			glTexImage2D(GL_TEXTURE_2D, 0, 4, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bImpactTexture[i]);
		else //if (i<6)
			glTexImage2D(GL_TEXTURE_2D, 0, 4, 32, 32, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bImpactTexture[i]);
	}
}

void fn_vInitGLTexFonts()
{ int i;

	fn_vGLInitFonts();

#ifdef PALETTED_TEXTURE

	if (g_bPaletteTexture)
	{	for (i=0;i<256;i++)
		{	p_bGLPalette[i][0]=p_bPalette[3*i];
			p_bGLPalette[i][1]=p_bPalette[3*i+1];
			p_bGLPalette[i][2]=p_bPalette[3*i+2];
			p_fRed[i]=(float)p_bPalette[3*i]/255;
			p_fGreen[i]=(float)p_bPalette[3*i+1]/255;
			p_fBlue[i]=(float)p_bPalette[3*i+2]/255;
			if (i==205)
			{	p_bGLPalette[i][3]=0;
				p_fAlpha[i]=0.0f;
			}
			else
			{	p_bGLPalette[i][3]=255;
				p_fAlpha[i]=1.0f;
			}
		}
		/*for (i=0;i<256;i++)
		{	p_bGLPalette[4*i]=(p_bPalette[3*i]>>3);
			p_bGLPalette[4*i+1]=(p_bPalette[3*i+1]>>3);
			p_bGLPalette[4*i+2]=(p_bPalette[3*i+2]>>3);
			if (i==205)
				p_bGLPalette[4*i+3]=0;
			else
				p_bGLPalette[4*i+3]=1;
		}*/

		/*glPixelMapfv(GL_PIXEL_MAP_I_TO_R,256,p_fRed);
		glPixelMapfv(GL_PIXEL_MAP_I_TO_G,256,p_fGreen);
		glPixelMapfv(GL_PIXEL_MAP_I_TO_B,256,p_fBlue);
		glPixelMapfv(GL_PIXEL_MAP_I_TO_A,256,p_fAlpha);*/

		glColorTableEXT2=wglGetProcAddress("glColorTableEXT");
		glColorTableEXT=(int (WINAPI *)(unsigned int,unsigned int,int,unsigned int,unsigned int,const void *))glColorTableEXT2;
		glGetColorTableParameterivEXT=wglGetProcAddress("glGetColorTableParameterivEXT");
	}
#endif

}

void fn_vInitGLTextures()
{ int i,j;
  int iTexMemory=0,iRealSprMemory=0;
#ifdef FLARES
  unsigned char *buf;	
  char filename[256];
  int width, height, components;
  GLenum minFilter, maxFilter;

  minFilter = GL_LINEAR_MIPMAP_LINEAR;
  maxFilter = GL_LINEAR;
#endif

	texobjs=(GLuint *)glMalloc(iNbGLTextures*sizeof(GLuint));
	/*for (i = 0; i < iNbGLTextures; i++)
		texobjs[i] = i+1;*/
	glGenTextures(iNbGLTextures,texobjs);
   
	for (i = 0; i < iNbGLTextures; i++) 
	{
		glBindTexture(GL_TEXTURE_2D, texobjs[i]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
#ifdef BILINEAR
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
#else
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
#endif
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE /*GL_DECAL*/);

#ifdef PALETTED_TEXTURE
		if ((g_bPaletteTexture)&&(!p_stGLTextures[i].a_stSubTex[0].bIsNZ))
		{	glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, p_stGLTextures[i].iWidth, p_stGLTextures[i].iHeight, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_stGLTextures[i].p_bRGBBuffer);
			iTexMemory+=p_stGLTextures[i].iWidth*p_stGLTextures[i].iHeight;
		}
		else
#endif
		{	glTexImage2D(GL_TEXTURE_2D, 0, 4, p_stGLTextures[i].iWidth, p_stGLTextures[i].iHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, p_stGLTextures[i].p_bRGBBuffer);

			iTexMemory+=p_stGLTextures[i].iWidth*p_stGLTextures[i].iHeight*4;
		}
		//glFree(p_stGLTextures[i].p_bRGBBuffer);
    }
	printf("GL Map Texture memory: %ld\n",iTexMemory);
	
	// Sprites
	iTexMemory=0;
	sprobjs=(GLuint *)glMalloc(iNbGLSprites*sizeof(GLuint));
	glGenTextures(iNbGLSprites,sprobjs);
	for (i = 0; i < iNbGLSprites; i++) 
	{
		glBindTexture(GL_TEXTURE_2D, sprobjs[i]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
#ifdef BILINEAR
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
#else
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
#endif
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_SPRITE
		if (g_bPaletteTexture)
		{	//glColorTableEXT(GL_TEXTURE_2D,GL_RGBA8,256,GL_RGBA,GL_UNSIGNED_BYTE,p_bGLPalette);
			glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
			//glGetColorTableParameterivEXT(GL_PROXY_TEXTURE_2D,GL_COLOR_TABLE_WIDTH_EXT,&width);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, p_stGLSprites[i].iWidth, p_stGLSprites[i].iHeight, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_stGLSprites[i].p_bRGBBuffer);
			//glTexImage2D(GL_TEXTURE_2D, 0, 4, p_stGLSprites[i].iWidth, p_stGLSprites[i].iHeight, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_stGLSprites[i].p_bRGBBuffer);
		}
		else
#endif
		glTexImage2D(GL_TEXTURE_2D, 0, 4, p_stGLSprites[i].iWidth, p_stGLSprites[i].iHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, p_stGLSprites[i].p_bRGBBuffer);

		//glFree(p_stGLSprites[i].p_bRGBBuffer);
		
		iTexMemory+=p_stGLSprites[i].iWidth*p_stGLSprites[i].iHeight*4;
		for (j=0;j<p_stGLSprites[i].iNbSubTextures;j++)
			iRealSprMemory+=p_stGLSprites[i].a_stSubTex[j].iWidth*p_stGLSprites[i].a_stSubTex[j].iHeight*4;
		
//#define SHOW_GL_SPRITES
#ifdef SHOW_GL_SPRITES
		for (j=0;j<p_stGLSprites[i].iNbFreeSpace;j++)
		{ int x,y,iU,iV;
			iU=p_stGLSprites[i].a_stFreeSpace[j].iU;
			iV=p_stGLSprites[i].a_stFreeSpace[j].iV;
			for (x=0;x<p_stGLSprites[i].a_stFreeSpace[j].iWidth;x++)
			for (y=0;y<p_stGLSprites[i].a_stFreeSpace[j].iHeight;y++)
			{	p_stGLSprites[i].p_bRGBBuffer[4*((x+iU)+(y+iV)*SPRITE_WIDTH)]=255;
				p_stGLSprites[i].p_bRGBBuffer[4*((x+iU)+(y+iV)*SPRITE_WIDTH)+1]=0;
				p_stGLSprites[i].p_bRGBBuffer[4*((x+iU)+(y+iV)*SPRITE_WIDTH)+2]=0;
				p_stGLSprites[i].p_bRGBBuffer[4*((x+iU)+(y+iV)*SPRITE_WIDTH)+3]=255;
			}
		}
#endif
    }
	printf("GL Sprite Texture memory: %ld\n",iTexMemory);
	printf("Sprite Texture memory (original): %ld\n",iRealSprMemory);
//	fn_vSaveSprites();	// Save all the GLSprites

// Coronas...
	GL_LoadCoronaTexture();

	//g_iCorona=sprobjs[iNbGLSprites-1]+50;
	glGenTextures(1,(unsigned int *)&g_iCorona);

	//glBindTexture(GL_TEXTURE_2D, texobjs[iNbGLTextures+iNbGLSprites]);
	glBindTexture(GL_TEXTURE_2D, g_iCorona);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	glTexImage2D(GL_TEXTURE_2D, 0, 4, 128, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bCoronaTexture);
	//glTexImage2D(GL_TEXTURE_2D, 0, 4, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bCoronaTexture);
// Light
	glGenTextures(1,(unsigned int *)&g_iParticle);
	glBindTexture(GL_TEXTURE_2D, g_iParticle);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	//glTexImage2D(GL_TEXTURE_2D, 0, 4, 128, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bLightTexture);
	glTexImage2D(GL_TEXTURE_2D, 0, 4, 8, 8, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bLightTexture);

#ifdef FLARES
// Flares
/*for (i = 0; i < 6; i++) 
	{
	iNbGLSprites++;
	g_iFlare[i] = sprobjs[iNbGLSprites-1]+50+i+2;
	
    glBindTexture(GL_TEXTURE_2D, g_iFlare[i]);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minFilter);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, maxFilter);
    
	sprintf(filename, "Flare%d.BW", i+1);
	
	buf = load_luminance(filename, &width, &height, &components);
    gluBuild2DMipmaps(GL_TEXTURE_2D, 1, width, height, GL_LUMINANCE, GL_UNSIGNED_BYTE, buf);
    
	free(buf);

	//printf("DEBG - SET: g_iFlare %d\n", i);
	}*/

	
	glGenTextures(10,g_iShine);
for (i = 0; i < 10; i++) 
  {
    iNbGLSprites++;
	//g_iShine[i] = sprobjs[iNbGLSprites-1]+50+i+2;

	//glBindTexture(GL_TEXTURE_2D, shineTex[i]);
	glBindTexture(GL_TEXTURE_2D, g_iShine[i]);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minFilter);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, maxFilter);
    
	sprintf(filename, "Shine%d.BW", i);

	buf = load_luminance(filename, &width, &height, &components);
    gluBuild2DMipmaps(GL_TEXTURE_2D, 1, width, height, GL_LUMINANCE, GL_UNSIGNED_BYTE, buf);
    
	free(buf);

	//printf("DEBG: g_iShine %d\n", i);
  }
#endif
// Bullet impact
	GL_LoadImpactTextures();
	//g_iImpact=sprobjs[iNbGLSprites-1]+70;
	glGenTextures(7,(unsigned int *)g_iImpact);

	for (i=0;i<7;i++)
	{	glBindTexture(GL_TEXTURE_2D, g_iImpact[i]);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

		if (i==0)
			glTexImage2D(GL_TEXTURE_2D, 0, 4, 32, 32, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bImpactTexture[i]);
		else
		if (i<3)
			glTexImage2D(GL_TEXTURE_2D, 0, 4, 64, 64, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bImpactTexture[i]);
		else //if (i<6)
			glTexImage2D(GL_TEXTURE_2D, 0, 4, 32, 32, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bImpactTexture[i]);
		/*else
			glTexImage2D(GL_TEXTURE_2D, 0, 4, 64, 32, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_p_bImpactTexture[i]);*/

		//glglFree(g_p_bImpactTexture[i]);
	}
	
	g_bOnTheFly=TRUE;
}

void fn_vAllocTextureMemory()
{
//	p_stGLTextures=(GLTexture *)glMalloc((numtextures+numflats)*sizeof(GLTexture));
//	a_iGLTexTranslation=(int *)glMalloc((numtextures+numflats)*sizeof(int));
	p_stGLTextures=(GLTexture *)glMalloc(sizeof(GLTexture));
	a_iGLTexTranslation=(int *)glMalloc(sizeof(int));
	p_bPalette=(unsigned char *)W_CacheLumpName("PLAYPAL", PU_STATIC);
	iNbGLTextures=0;
	iNbTexturesInMap=0;
	g_bOnTheFly=FALSE;

	GL_vRegisterAnimatedTextures();
}

GLboolean fn_bWTAlreadyRegistered(int iTexNum,int *iGLIndex)	// MR2606
{ int i;

	for (i=0;i<iNbTexturesInMap;i++)
		if (p_stGLTexArray[i].iTexID==iTexNum)
		{	*iGLIndex=i;
			return true;
		}
	*iGLIndex=-1;
	return false;
}

GLboolean fn_bFTAlreadyRegistered(int iTexNum,int *iGLIndex)	// MR2606
{ int i;

	for (i=0;i<iNbTexturesInMap;i++)
		if (p_stGLTexArray[i].iFlatID==iTexNum)
		{	*iGLIndex=i;
			return true;
		}
	*iGLIndex=-1;
	return false;
}

//void fn_vRegisterFlatTexture(char *szName)
int fn_vRegisterFlatTexture(int flattex)
{ unsigned char *p_bTexture;
  int i,lump,x,y;

	if (fn_bFTAlreadyRegistered(flattex,&i))	// MR1410
		return i;

	//i=R_FlatNumForName(szName);
	i=flattex;
	/*if (!strncmp(szName,"F_SKY1",8))
		return;*/		// a voir
	//flatmemory = 0;
	lump = firstflat + i;
	//flatmemory += lumpinfo[lump].size;
	p_bTexture=(unsigned char *)W_CacheLumpNum(lump, PU_CACHE);

	p_stGLTextures=(GLTexture *)glRealloc(p_stGLTextures,sizeof(GLTexture)*(iNbGLTextures+1));
	a_iGLTexTranslation=(int *)glRealloc(a_iGLTexTranslation,sizeof(int)*(iNbGLTextures+1));

	p_stGLTextures[iNbGLTextures].iWidth=FLAT_TEX_SIZE;
	p_stGLTextures[iNbGLTextures].iHeight=FLAT_TEX_SIZE;

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
		p_stGLTextures[iNbGLTextures].p_bRGBBuffer=(unsigned char *)glMalloc(FLAT_TEX_SIZE*FLAT_TEX_SIZE);
	else
#endif
	p_stGLTextures[iNbGLTextures].p_bRGBBuffer=(unsigned char *)glMalloc(FLAT_TEX_SIZE*FLAT_TEX_SIZE*4);

	p_stGLTextures[iNbGLTextures].a_stSubTex=(GLSubTexture *)glMalloc(sizeof(GLSubTexture));
	p_stGLTextures[iNbGLTextures].a_stFreeSpace=(GLSubTexture *)glMalloc(sizeof(GLSubTexture));
	p_stGLTextures[iNbGLTextures].iNbSubTextures=1;
	p_stGLTextures[iNbGLTextures].a_stSubTex[0].iU=0;
	p_stGLTextures[iNbGLTextures].a_stSubTex[0].iV=0;
	p_stGLTextures[iNbGLTextures].a_stSubTex[0].iWidth=FLAT_TEX_SIZE;
	p_stGLTextures[iNbGLTextures].a_stSubTex[0].iHeight=FLAT_TEX_SIZE;
	p_stGLTextures[iNbGLTextures].a_stSubTex[0].bIsNZ=0;
	p_stGLTextures[iNbGLTextures].iNbFreeSpace=0;
	p_stGLTextures[iNbGLTextures].a_stFreeSpace[0].iU=0;
	p_stGLTextures[iNbGLTextures].a_stFreeSpace[0].iV=0;
	p_stGLTextures[iNbGLTextures].a_stFreeSpace[0].iWidth=0;
	p_stGLTextures[iNbGLTextures].a_stFreeSpace[0].iHeight=0;

	for (x=0;x<FLAT_TEX_SIZE;x++)
	{ 
#define Y y
		for (y=0;y<FLAT_TEX_SIZE;y++)
		{	
#ifdef PALETTED_TEXTURE
			if (g_bPaletteTexture)
				p_stGLTextures[iNbGLTextures].p_bRGBBuffer[x*FLAT_TEX_SIZE+Y]=p_bTexture[y+x*FLAT_TEX_SIZE];
			else
#endif
			{	p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(x*FLAT_TEX_SIZE+Y)]=p_bPalette[p_bTexture[y+x*FLAT_TEX_SIZE]*3];
				p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(x*FLAT_TEX_SIZE+Y)+1]=p_bPalette[p_bTexture[y+x*FLAT_TEX_SIZE]*3+1];
				p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(x*FLAT_TEX_SIZE+Y)+2]=p_bPalette[p_bTexture[y+x*FLAT_TEX_SIZE]*3+2];
				p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(x*FLAT_TEX_SIZE+Y)+3]=255;
			}
		}
	}

	a_iGLTexTranslation[iNbGLTextures]=iNbGLTextures;
	
	if (!iNbTexturesInMap)
		p_stGLTexArray=(GLTexArray *)glMalloc(++iNbTexturesInMap*sizeof(GLTexArray));
	else
		p_stGLTexArray=(GLTexArray *)glRealloc(p_stGLTexArray,++iNbTexturesInMap*sizeof(GLTexArray));
	/*for (k=0;k<8;k++)
		p_stGLTexArray[iNbTexturesInMap-1].szTexName[k]=szName[k];*/
	p_stGLTexArray[iNbTexturesInMap-1].iFlatID=flattex;
	p_stGLTexArray[iNbTexturesInMap-1].iTexID=-1;
	p_stGLTexArray[iNbTexturesInMap-1].iGLTexIndex=iNbGLTextures++;
	p_stGLTexArray[iNbTexturesInMap-1].iUVIndex=0;

	return iNbGLTextures-1;
}

int fn_iGetTexHeightGL(int iHeight)
{
	if (g_b3Dfx&&(iHeight>256))	// MR0709
		return 256;
	if (/*(iHeight==2)||(iHeight==4)||(iHeight==8)||*/(iHeight==16)||(iHeight==32)||(iHeight==64)||(iHeight==128)||(iHeight==256)||(iHeight==512)||(iHeight==1024))
		return iHeight;
/*	if (iHeight<2)		// DOOM_GL: Bug in 3Dfx beta 2.1 drivers. Tex Width<16 => White!!
		return 2;
	if (iHeight<4)
		return 4;
	if (iHeight<8)
		return 8;*/
	if (iHeight<16)
		return 16;
	if (iHeight<32)
		return 32;
	if (iHeight<64)
		return 64;
	if (iHeight<128)
		return 128;
	if (iHeight<256)
		return 256;
	if (iHeight<512)
		return 512;
	if (iHeight<1024)
		return 1024;
	return 1024;
}

#ifdef DOOM_GL
#define NB_NON_TRANSP_TEX 14
char szNonTranspTex[NB_NON_TRANSP_TEX][9]= { "COMPTILE","LITEBLU4","COMPSTA1","DOORBLU","DOORBLU2","SW2SKIN","COMPBLUE","SW1BLUE",
	"SW2BLUE","TEKGREN3","PLAT1", "SKINEDGE","PANBLUE","COMPUTE1" };
// MR2506
#define NB_TRANSP_TEX 17
char szTranspTex[NB_TRANSP_TEX][9]= { "BRNBIGC","BRNBIGL","BRNBIGR","BRNSMAL1","BRNSMAL2","BRNSMALC","BRNSMALL","BRNSMALR","MIDBRN1",
	"MIDGRATE","MIDVINE1","MIDVINE2","MIDBARS1","MIDBARS3","MIDBRONZ","MIDSPACE","IIEBLOD1"  };

#elif GL_HEXEN
#define NB_NON_TRANSP_TEX 7
char szNonTranspTex[NB_NON_TRANSP_TEX][9]= { "FOREST01","GLASS01","GLASS02","GLASS03","GLASS04","GLASS05","GLASS06" };

#define NB_TRANSP_TEX 31
char szTranspTex[NB_TRANSP_TEX][9]= { "GATE01","GATE02","GATE03","GATE04","GATE51","GATE52","GATE53","VILL06","VILL07","VILL08",
	"WEB1_L","WEB1_R","WEB2_L","WEB2_R","WEB3","GLASS07","TOMB18","BLANK","CASTLE09","CAVE11","FIRE16","FOREST12","MONK24","PRTL07",
	"SEWER14","SWAMP07","TOMB13","TPORTX","SEWER03","SEWER04","FOREST06"  };

#else
#define NB_NON_TRANSP_TEX 8
char szNonTranspTex[NB_NON_TRANSP_TEX][9]= { "MOSAIC1","MOSAIC2","MOSAIC3","MOSAIC4","MOSAIC5","STNGLS1","STNGLS2","STNGLS3"};

#define NB_TRANSP_TEX 11
char szTranspTex[NB_TRANSP_TEX][9]= { "GATMETL","GATMETL2","GATMETL3","GATMETL4","GATMETL5","WDGAT64","WEB1_B","WEB1_F","WEB2_B","WEB2_F",
	"WEB3_M"  };

#endif
GLboolean fn_bTexIsNotTransp(char *szName)
{ int i;

	for (i=0;i<NB_NON_TRANSP_TEX;i++)
		if (!strncmp(szName,szNonTranspTex[i],8))
			return TRUE;
	return FALSE;
}

GLboolean fn_bTexIsTransp(char *szName)
{ int i;
	
	for (i=0;i<NB_TRANSP_TEX;i++)
		if (!strncmp(szName,szTranspTex[i],8))
			return TRUE;
	return FALSE;
}

int iNbHandle=0;
int hHandle[2];
void GL_vHandle(int handle)
{
	if (iNbHandle<2)
		hHandle[iNbHandle++]=handle;
}
// MR0709
GLboolean fn_bTextureIsTransp(texture_t *texture)
{ int x,i;
  patch_t *patch;
  GLboolean bExtern,bTransp;

	/*if (texture->width<=256)	// original doom texture are < 256 and original transp texture are in the szTranspTex array.
		return FALSE;*/

	bExtern=FALSE;
	bTransp=FALSE;
	for (i=0;i<texture->patchcount;i++)
	{	patch = (struct patch_s *)W_CacheLumpNum (texture->patches[i].patch, PU_CACHE);
		if ((lumpinfo[texture->patches[i].patch].handle!=hHandle[0])&&		// ZDoom.wad
			(lumpinfo[texture->patches[i].patch].handle!=hHandle[1]))		// Doom.wad
			bExtern=TRUE;
		for (x=0;x<patch->width;x++)
		{ column_t *p_bColumn_t;
		  byte *p_bColumn;
			
			p_bColumn_t=(column_t *)((byte *)patch+patch->columnofs[x]);
			//if (p_bColumn_t->length!=patch->height)
			if ((p_bColumn_t->length<patch->height)&&(p_bColumn_t->length<texture->height))
				//return TRUE;
				bTransp=TRUE;
			for ( ; p_bColumn_t->topdelta != 0xff ; )
			{
				p_bColumn=(byte *)p_bColumn_t + 3;
				p_bColumn_t = (column_t *)(  (byte *)p_bColumn_t + p_bColumn_t->length + 4);
			}
		}
	}
	//return FALSE;
	return bTransp & bExtern;
}

int fn_vRegisterWallTextures(int iTexNum,texture_t	*texture)
{ int iGLIndex,iU,iV,iFreeSpace,iSubIndex;
  int iGLTexHeight;
  int iGLTexWidth;	// DOOM_GL
  //int i;
	
	if (fn_bWTAlreadyRegistered(iTexNum,&iGLIndex))
		return iGLIndex;

/*	if (!strncmp(texture->name,"WFALL1",8))
		printf("prout");*/

	//for (i=0 ; i<numtextures ; i++)
	{ 
		iGLIndex=-1;
		
		if (iGLIndex==-1)
		{	iU=0;
			iV=0;
			iGLTexWidth=fn_iGetTexHeightGL(texture->width);
			iGLTexHeight=fn_iGetTexHeightGL(texture->height);

			p_stGLTextures=(GLTexture *)glRealloc(p_stGLTextures,sizeof(GLTexture)*(iNbGLTextures+1));
			a_iGLTexTranslation=(int *)glRealloc(a_iGLTexTranslation,sizeof(int)*(iNbGLTextures+1));

			//p_stGLTextures[iNbGLTextures].iWidth=texture->width;
			p_stGLTextures[iNbGLTextures].iWidth=iGLTexWidth;
			p_stGLTextures[iNbGLTextures].iHeight=iGLTexHeight;
			p_stGLTextures[iNbGLTextures].p_bRGBBuffer=(unsigned char *)glMalloc(iGLTexHeight*iGLTexWidth*4);
			memset(p_stGLTextures[iNbGLTextures].p_bRGBBuffer,0,iGLTexHeight*iGLTexWidth*4);

			p_stGLTextures[iNbGLTextures].a_stSubTex=(GLSubTexture *)glMalloc(sizeof(GLSubTexture));
			p_stGLTextures[iNbGLTextures].a_stFreeSpace=(GLSubTexture *)glMalloc(sizeof(GLSubTexture));
			p_stGLTextures[iNbGLTextures].iNbSubTextures=0;
			p_stGLTextures[iNbGLTextures].a_stSubTex[0].iU=0;
			p_stGLTextures[iNbGLTextures].a_stSubTex[0].iV=0;
			p_stGLTextures[iNbGLTextures].a_stSubTex[0].iWidth=texture->width;
			p_stGLTextures[iNbGLTextures].a_stSubTex[0].iHeight=texture->height;

			p_stGLTextures[iNbGLTextures].iNbFreeSpace=0;
			iGLIndex=iNbGLTextures++;
			iFreeSpace=0;
		}
					
		{ int x,y;

			iSubIndex=0;
			p_stGLTextures[iGLIndex].a_stSubTex[iSubIndex].bIsNZ=0;

			//fn_vStretchTexture(texture->width,texture->height,texture->width,iGLTexHeight);
			fn_vStretchTexture(texture->width,texture->height,iGLTexWidth,iGLTexHeight);

			if (!fn_bTexIsTransp(texture->name)&&!fn_bTextureIsTransp(texture))// MR0709
			{
				for (y=0;y<iGLTexHeight;y++)
				{ byte *p_bColumn;
					
#define Y y
					//for (x=0;x<texture->width;x++)
					for (x=0;x<iGLTexWidth;x++)
					{
						p_bColumn=R_GetColumn(iTexNum,xS[x]);
// MR2506
//						if ((p_bColumn[yS[y]]!=205)||fn_bTexIsNotTransp(texture->name))
						{	p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)]=p_bPalette[p_bColumn[yS[y]]*3];
							p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+1]=p_bPalette[p_bColumn[yS[y]]*3+1];
							p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+2]=p_bPalette[p_bColumn[yS[y]]*3+2];
							p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+3]=255;
						}
// MR2506
/*						else
						{	p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)]=255;
							p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+1]=0;
							p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+2]=0;
							p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+3]=0;
							p_stGLTextures[iGLIndex].a_stSubTex[iSubIndex].bIsNZ=1;
						}*/
					}
				}
#ifdef PALETTED_TEXTURE
				if ((g_bPaletteTexture)&&(!p_stGLTextures[iGLIndex].a_stSubTex[iSubIndex].bIsNZ))
				{
					p_stGLTextures[iGLIndex].p_bRGBBuffer=(unsigned char *)glRealloc(p_stGLTextures[iGLIndex].p_bRGBBuffer,iGLTexHeight*iGLTexWidth);
					for (y=0;y<iGLTexHeight;y++)
					{ byte *p_bColumn;
						
						for (x=0;x<iGLTexWidth;x++)
						{
							p_bColumn=R_GetColumn(iTexNum,xS[x]);
							p_stGLTextures[iGLIndex].p_bRGBBuffer[(x+iU)+(Y+iV)*iGLTexWidth]=p_bColumn[yS[y]];
						}
					}
				}
#endif
			}
			else	// tex is transp
			// MR0709
			{ patch_t *patch;
			  int i,j;
			  unsigned char *p_bRGBBuffer1;

				p_stGLTextures[iGLIndex].a_stSubTex[iSubIndex].bIsNZ=1;
				p_bRGBBuffer1=(unsigned char *)glMalloc(4*texture->width*texture->height);
				memset(p_bRGBBuffer1,0,4*texture->width*texture->height);
				for (i=0;i<texture->patchcount;i++)
				{	patch = (struct patch_s *)W_CacheLumpNum (texture->patches[i].patch, PU_CACHE);
					for (x=0;x<patch->width;x++)
					{ column_t *p_bColumn_t;
					  byte *p_bColumn;
						
						p_bColumn_t=(column_t *)((byte *)patch+patch->columnofs[x]);
						for ( ; p_bColumn_t->topdelta != 0xff ; )
						{
							p_bColumn=(byte *)p_bColumn_t + 3;

	#undef Y
	#define Y (j+p_bColumn_t->topdelta)

							for (j=0;j<p_bColumn_t->length;j++)
								if ((texture->patches[i].originx+x<texture->width)&&(Y<texture->height))
								{	p_bRGBBuffer1[4*(texture->patches[i].originx+x+Y*texture->width)]=p_bPalette[p_bColumn[j]*3];
									p_bRGBBuffer1[4*(texture->patches[i].originx+x+Y*texture->width)+1]=p_bPalette[p_bColumn[j]*3+1];
									p_bRGBBuffer1[4*(texture->patches[i].originx+x+Y*texture->width)+2]=p_bPalette[p_bColumn[j]*3+2];
									p_bRGBBuffer1[4*(texture->patches[i].originx+x+Y*texture->width)+3]=255;
								}
							p_bColumn_t = (column_t *)(  (byte *)p_bColumn_t + p_bColumn_t->length + 4);
						}
					}
				 }

#undef Y
#define Y y
				for (x=0;x<iGLTexWidth;x++)
				for (y=0;y<iGLTexHeight;y++)
				{	if ((xS[x]+yS[y]*texture->width)<texture->width*texture->height)
					{	p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)]=p_bRGBBuffer1[4*(xS[x]+yS[y]*texture->width)];
						p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+1]=p_bRGBBuffer1[4*(xS[x]+yS[y]*texture->width)+1];
						p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+2]=p_bRGBBuffer1[4*(xS[x]+yS[y]*texture->width)+2];
						p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+3]=p_bRGBBuffer1[4*(xS[x]+yS[y]*texture->width)+3];
					}
				}

				glFree(p_bRGBBuffer1);
			}	// end tex transp
			/*{ patch_t *patch;
			  int j;
			  unsigned char *p_bRGBBuffer1;

				p_stGLTextures[iGLIndex].a_stSubTex[iSubIndex].bIsNZ=1;
				patch = W_CacheLumpNum (texture->patches->patch, PU_CACHE);
				p_bRGBBuffer1=(unsigned char *)glMalloc(4*patch->width*patch->height);
				memset(p_bRGBBuffer1,0,4*patch->width*patch->height);
				for (x=0;x<patch->width;x++)
				{ column_t *p_bColumn_t;
				  byte *p_bColumn;
					
					p_bColumn_t=(column_t *)((byte *)patch+patch->columnofs[x]);
					for ( ; p_bColumn_t->topdelta != 0xff ; )
					{
						p_bColumn=(byte *)p_bColumn_t + 3;

#undef Y
#define Y (j+p_bColumn_t->topdelta)

						for (j=0;j<p_bColumn_t->length;j++)
						{	p_bRGBBuffer1[4*(x+Y*patch->width)]=p_bPalette[p_bColumn[j]*3];
							p_bRGBBuffer1[4*(x+Y*patch->width)+1]=p_bPalette[p_bColumn[j]*3+1];
							p_bRGBBuffer1[4*(x+Y*patch->width)+2]=p_bPalette[p_bColumn[j]*3+2];
							p_bRGBBuffer1[4*(x+Y*patch->width)+3]=255;
						}
						p_bColumn_t = (column_t *)(  (byte *)p_bColumn_t + p_bColumn_t->length + 4);
					}
				}
				
#undef Y
#define Y y
				for (x=0;x<iGLTexWidth;x++)
				for (y=0;y<iGLTexHeight;y++)
				if ((xS[x]+yS[y]*patch->width)<patch->width*patch->height)
				{	p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)]=p_bRGBBuffer1[4*(xS[x]+yS[y]*patch->width)];
					p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+1]=p_bRGBBuffer1[4*(xS[x]+yS[y]*patch->width)+1];
					p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+2]=p_bRGBBuffer1[4*(xS[x]+yS[y]*patch->width)+2];
					p_stGLTextures[iGLIndex].p_bRGBBuffer[4*((x+iU)+(Y+iV)*iGLTexWidth)+3]=p_bRGBBuffer1[4*(xS[x]+yS[y]*patch->width)+3];
				}

				glglFree(p_bRGBBuffer1);
			}	// end tex transp*/

			p_stGLTextures[iGLIndex].iNbSubTextures++;

			a_iGLTexTranslation[iGLIndex]=iGLIndex;

			if (!iNbTexturesInMap)
				p_stGLTexArray=(GLTexArray *)glMalloc(++iNbTexturesInMap*sizeof(GLTexArray));
			else
				p_stGLTexArray=(GLTexArray *)glRealloc(p_stGLTexArray,++iNbTexturesInMap*sizeof(GLTexArray));
			//for (k=0;k<8;k++)
			//	p_stGLTexArray[iNbTexturesInMap-1].szTexName[k]=texture->name[k];
			p_stGLTexArray[iNbTexturesInMap-1].iTexID=R_TextureNumForName(texture->name);
			p_stGLTexArray[iNbTexturesInMap-1].iFlatID=-1;
			p_stGLTexArray[iNbTexturesInMap-1].iGLTexIndex=iGLIndex;
			p_stGLTexArray[iNbTexturesInMap-1].iUVIndex=iSubIndex;
		}

	}
/*	if (!strncmp(texture->name,"WFALL1",8))
		fn_vSaveRAW("Debug.raw",p_stGLTextures[iGLIndex].p_bRGBBuffer,iGLTexWidth,iGLTexHeight);*/

	return iGLIndex;
}

//#pragma optimize( "", on )

//int fn_iGetGLTexturef(char *szTexName,short xOffset,short yOffset,float *fU1,float *fU2,float *fV1,float *fV2,float *fU1Off,float *fV2Off,int *iSubTextIndex)
int fn_iGetGLTexturef(short sTexture,short xOffset,short yOffset,float *fU1,float *fU2,float *fV1,float *fV2,float *fU1Off,float *fV2Off,int *iSubTextIndex)
{ int i,iUVIndex,iGLTexIndex=-1;

	for (i=0;i<iNbTexturesInMap;i++)
	{
		//if (!strncmp(szTexName,p_stGLTexArray[i].szTexName,8))
		if ((p_stGLTexArray[i].iTexID==sTexture)||
			((p_stGLTexArray[i].iTexID==-1)&&(p_stGLTexArray[i].iFlatID==-1)&&(sTexture==-2)))	// Sky
		{
			iGLTexIndex=p_stGLTexArray[i].iGLTexIndex;
			iUVIndex=p_stGLTexArray[i].iUVIndex;
			*iSubTextIndex=iUVIndex;

			if (xOffset>=p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iWidth)
				xOffset=0;
			if (yOffset>=p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iHeight)
				yOffset=0;

// MR0709			
/*			*fU1Off=(float)(p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iU+xOffset)/(float)p_stGLTextures[iGLTexIndex].iWidth;
			*fU1=(float)(p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iU)/(float)p_stGLTextures[iGLTexIndex].iWidth;
			*fU2=(float)(p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iU+p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iWidth)/(float)p_stGLTextures[iGLTexIndex].iWidth;

			*fV1=0.0f;
			*fV2=1.0f;
			*fV2Off=(float)(p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iV+yOffset)/(float)p_stGLTextures[iGLTexIndex].iHeight;*/
			*fU1Off=(float)(p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iU+xOffset)/(float)p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iWidth;
			*fU1=(float)(p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iU)/(float)p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iWidth;
			*fU2=(float)(p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iU+p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iWidth)/(float)p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iWidth;

			*fV1=0.0f;
			*fV2=1.0f;
			*fV2Off=(float)(p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iV+yOffset)/(float)p_stGLTextures[iGLTexIndex].a_stSubTex[iUVIndex].iHeight;

			return iGLTexIndex;
		}
	}
	return iGLTexIndex;
}


//int fn_iGetGLFlatTexturef(char *szTexName)
int fn_iGetGLFlatTexturef(int flattex)
{ int i,iGLTexIndex=-1;

	for (i=0;i<iNbTexturesInMap;i++)
	{
		//if (!strncmp(szTexName,p_stGLTexArray[i].szTexName,8))
		if (p_stGLTexArray[i].iFlatID==flattex)
		{
			iGLTexIndex=p_stGLTexArray[i].iGLTexIndex;

			return iGLTexIndex;
		}
	}
	return iGLTexIndex;
}

#ifdef DOOM_GL
char szSkyName[5][8]={ "SKY1","SKY2", "SKY3", "SKY4", "SKY3" };
#elif GL_HEXEN

extern fixed_t Sky1ScrollDelta;
extern fixed_t Sky2ScrollDelta;
extern int Sky1Texture;
extern int Sky2Texture;
extern fixed_t Sky1ColumnOffset;
extern fixed_t Sky2ColumnOffset;
extern int skyflatnum;
extern int skytexturemid;
extern fixed_t skyiscale;
extern H_boolean DoubleSky;

#else
char szSkyName[6][8]={ "SKY1","SKY2", "SKY3", "SKY1", "SKY3", "SKY1" };
#endif

int gamemap;
void fn_vLoadSkyTexture(int episode)
{ texture_t		*texture;
  int skytexture,j,lump;
  int x,y;
  patch_t		*realpatch;

	if (gamemode == commercial)
	{	strupr(level.mapname);
		sscanf(level.mapname,"MAP%d",&gamemap);
	}
	else	
		episode=episode/10+1;
#ifdef DOOM_GL
    if ( (gamemode == commercial)
	 /*|| ( gamemode == pack_tnt )
	 || ( gamemode == pack_plut ) */)
    {
	skytexture = R_TextureNumForName ("SKY3");
	if (gamemap < 12)
	    skytexture = R_TextureNumForName ("SKY1");
	else
	    if (gamemap < 21)
		skytexture = R_TextureNumForName ("SKY2");
    }
	else
#endif
#ifndef GL_HEXEN
	skytexture = R_TextureNumForName(szSkyName[episode-1]);
#else
	if (episode==1)
	{	skytexture = Sky1Texture;
		GL_Sky1Texture=iNbGLTextures+1;
	}
	else
	{	skytexture = Sky2Texture;
		GL_Sky2Texture=iNbGLTextures+1;
	}
#endif
	texture = textures[skytexture];
	for (j=0 ; j<texture->patchcount ; j++)
	{ 

		lump = texture->patches[j].patch;
		realpatch = (struct patch_s *)W_CacheLumpNum (lump, PU_CACHE);
	}

	p_stGLTextures=(GLTexture *)glRealloc(p_stGLTextures,sizeof(GLTexture)*(iNbGLTextures+1));
	a_iGLTexTranslation=(int *)glRealloc(a_iGLTexTranslation,sizeof(int)*(iNbGLTextures+1));

	p_stGLTextures[iNbGLTextures].iWidth=TEX_SKY_W;
	p_stGLTextures[iNbGLTextures].iHeight=TEX_SKY_H;

#ifndef GL_HEXEN
	if (g_bPaletteTexture)	// MR1405
#else
	if (g_bPaletteTexture&&
		(!DoubleSky||
		(DoubleSky&&(episode==2))))
#endif
		p_stGLTextures[iNbGLTextures].p_bRGBBuffer=(unsigned char *)glMalloc(TEX_SKY_W*TEX_SKY_H);
	else
		p_stGLTextures[iNbGLTextures].p_bRGBBuffer=(unsigned char *)glMalloc(TEX_SKY_W*TEX_SKY_H*4);

	p_stGLTextures[iNbGLTextures].a_stSubTex=(GLSubTexture *)glMalloc(sizeof(GLSubTexture));
	p_stGLTextures[iNbGLTextures].a_stFreeSpace=(GLSubTexture *)glMalloc(sizeof(GLSubTexture));
	p_stGLTextures[iNbGLTextures].iNbSubTextures=1;
	p_stGLTextures[iNbGLTextures].a_stSubTex[0].iU=0;
	p_stGLTextures[iNbGLTextures].a_stSubTex[0].iV=0;
	p_stGLTextures[iNbGLTextures].a_stSubTex[0].iWidth=TEX_SKY_W;
	p_stGLTextures[iNbGLTextures].a_stSubTex[0].iHeight=TEX_SKY_H;
#ifdef GL_HEXEN
	if (DoubleSky&&(episode==1))
		p_stGLTextures[iNbGLTextures].a_stSubTex[0].bIsNZ=1;
	else
#endif
		p_stGLTextures[iNbGLTextures].a_stSubTex[0].bIsNZ=0;

	p_stGLTextures[iNbGLTextures].iNbFreeSpace=0;
	p_stGLTextures[iNbGLTextures].a_stFreeSpace[0].iU=0;
	p_stGLTextures[iNbGLTextures].a_stFreeSpace[0].iV=0;
	p_stGLTextures[iNbGLTextures].a_stFreeSpace[0].iWidth=0;
	p_stGLTextures[iNbGLTextures].a_stFreeSpace[0].iHeight=0;

	fn_vStretchTexture(realpatch->width,realpatch->height,TEX_SKY_W,TEX_SKY_H);

	for (x=0;x<TEX_SKY_W;x++)
	{ byte *p_bColumn;
		
		p_bColumn=(byte *)realpatch+realpatch->columnofs[x]+3;
#undef Y
#define Y y
		//for (y=0;y<realpatch->height;y++)
		for (y=0;y<TEX_SKY_H;y++)
#ifndef GL_HEXEN
			if (g_bPaletteTexture)	// MR1405
#else
			if (g_bPaletteTexture&&
				(!DoubleSky||
				(DoubleSky&&(episode==2))))
#endif
				//p_stGLTextures[iNbGLTextures].p_bRGBBuffer[Y*TEX_SKY_W+x]=p_bColumn[y];
				p_stGLTextures[iNbGLTextures].p_bRGBBuffer[Y*TEX_SKY_W+x]=p_bColumn[yS[y]];
			else
			{	//p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(Y*TEX_SKY_W+x)]=p_bPalette[p_bColumn[y]*3];
				//p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(Y*TEX_SKY_W+x)+1]=p_bPalette[p_bColumn[y]*3+1];
				//p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(Y*TEX_SKY_W+x)+2]=p_bPalette[p_bColumn[y]*3+2];
				p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(Y*TEX_SKY_W+x)]=p_bPalette[p_bColumn[yS[y]]*3];
				p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(Y*TEX_SKY_W+x)+1]=p_bPalette[p_bColumn[yS[y]]*3+1];
				p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(Y*TEX_SKY_W+x)+2]=p_bPalette[p_bColumn[yS[y]]*3+2];
#ifdef GL_HEXEN
				if (DoubleSky&&(episode==1)&&!p_bColumn[y])
					p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(Y*TEX_SKY_W+x)+3]=0;
				else
#endif
					p_stGLTextures[iNbGLTextures].p_bRGBBuffer[4*(Y*TEX_SKY_W+x)+3]=255;
			}
	}

	p_stGLTexArray=(GLTexArray *)glRealloc(p_stGLTexArray,++iNbTexturesInMap*sizeof(GLTexArray));
	/*for (k=0;k<8;k++)
		p_stGLTexArray[iNbTexturesInMap-1].szTexName[k]=szSkyName[episode-1][k];*/

	p_stGLTexArray[iNbTexturesInMap-1].iFlatID=-1;
	p_stGLTexArray[iNbTexturesInMap-1].iTexID=-1;
	p_stGLTexArray[iNbTexturesInMap-1].iGLTexIndex=iNbGLTextures++;
	p_stGLTexArray[iNbTexturesInMap-1].iUVIndex=0;
//	fn_vSaveRAW("toto.raw",p_stGLTextures[iNbGLTextures-1].p_bRGBBuffer,p_stGLTextures[iNbGLTextures-1].iWidth,p_stGLTextures[iNbGLTextures-1].iHeight);
}

#ifdef GL_HEXEN
void fn_vLoadSkyTextures()
{
	fn_vLoadSkyTexture(1);
	//if (DoubleSky)
	if (Sky1Texture!=Sky2Texture)
		fn_vLoadSkyTexture(2);
}
#endif

void fn_vCheckIfTextureIsAnimated(int tex)
{
  int i,j;
  texture_t	*texture;
  char bAnim=0;

	for (i = 0;i < MAXSWITCHES;i++)
	{
		if (tex==switchlist[2*i])
		{	glSwitchList[i*2]=iNbGLTextures-1;
			texture = textures[switchlist[2*i+1]];
			tex=switchlist[2*i+1];
			fn_vRegisterWallTextures(tex,texture);
			glSwitchList[i*2+1]=iNbGLTextures-1;
		}

		if (tex==switchlist[2*i+1])
		{	texture = textures[switchlist[2*i]];
			if (fn_bWTAlreadyRegistered(switchlist[2*i],&j))
				return;
			glSwitchList[i*2+1]=iNbGLTextures-1;
			tex=switchlist[2*i];
			fn_vRegisterWallTextures(tex,texture);
			glSwitchList[i*2]=iNbGLTextures-1;
		}
	}
}

void GL_vRegisterAnimatedTextures()
{ int i,j;
  texture_t	*texture;
  static GLboolean bFirstTime=true;	// MR2510
  static anim_t*  OrigAnims;

	if (bFirstTime)
	{
		fn_vSetMemoryMode(FIX);
		OrigAnims=(anim_t *)glMalloc(maxanims*sizeof(anim_t));
		memcpy(OrigAnims,anims,maxanims*sizeof(anim_t));
		fn_vSetMemoryMode(LEVEL);
	}

	bFirstTime=false;

	for(i = 0; i<(int)maxanims; i++)
	{
		if (anims[i].uniqueframes)
		{	if (anims[i].istexture)	// Walls textures
			{	
				//for (j=lastanim->basepic;j<lastanim->basepic+lastanim->numframes;j++)
				for (j=0;j<anims[i].numframes;j++)
				{	texture = textures[OrigAnims[i].framepic[j]];
					if (texture)
						anims[i].framepic[j]=fn_vRegisterWallTextures(OrigAnims[i].framepic[j],texture);
				}
				anims[i].basepic=anims[i].framepic[0];
			}
			else	// Flat textures
			{
				for (j=0;j<anims[i].numframes;j++)
				{	texture = textures[OrigAnims[i].framepic[j]];
					if (texture)
						anims[i].framepic[j]=fn_vRegisterFlatTexture(OrigAnims[i].framepic[j]);
				}
				anims[i].basepic=anims[i].framepic[0];
			}
		}
		else
		{	if (anims[i].istexture)	// Walls textures
			{	
				//for (j=lastanim->basepic;j<lastanim->basepic+lastanim->numframes;j++)
				for (j=0;j<anims[i].numframes;j++)
				{	texture = textures[OrigAnims[i].basepic+j];
					if (texture)
						anims[i].framepic[j]=fn_vRegisterWallTextures(OrigAnims[i].basepic+j,texture);
				}
				anims[i].basepic=anims[i].framepic[0];
			}
			else	// Flat textures
			{
				for (j=0;j<anims[i].numframes;j++)
				{	texture = textures[OrigAnims[i].basepic+j];
					if (texture)
						anims[i].framepic[j]=fn_vRegisterFlatTexture(OrigAnims[i].basepic+j);
				}
				anims[i].basepic=anims[i].framepic[0];
			}
		}
	}
	
	// SWITCHES
	for (i=0;i<2*numswitches;i++)
	{
		glSwitchList[i]=fn_vRegisterWallTextures(switchlist[i],textures[switchlist[i]]);
	}
}

void fn_vCheckIfFlatIsAnimated(int tex)
{
}

void GL_PurgeTextures()
{
	//glDeleteTextures(iNbGLTextures+iNbGLSprites,texobjs);
	glDeleteTextures(iNbGLTextures,texobjs);
	glDeleteTextures(iNbGLSprites,sprobjs);
}

GLint fn_iIsTextureRegistered(int iTexNum)
{ int i;

	for (i=0;i<iNbTexturesInMap;i++)
	{
		if (p_stGLTexArray[i].iTexID==iTexNum)
			return i;
	}
	return -1;
}

GLint GL_vRegisterWallTextureOnTheFly(int iTexNum)
{ texture_t	*texture;
  GLint iTex;

	if ((iTex=fn_iIsTextureRegistered(iTexNum))!=-1)
		return iTex;
	texture=textures[iTexNum];
	fn_vRegisterWallTextures(iTexNum,texture);
	iTex=iNbGLTextures-1;

	texobjs=(GLuint *)glRealloc(texobjs,iNbGLTextures*sizeof(GLuint));
	//texobjs[iNbGLTextures-1] = iNbGLTextures;
	glGenTextures(1,texobjs+iNbGLTextures-1);

	glBindTexture(GL_TEXTURE_2D, texobjs[iNbGLTextures-1]);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE /*GL_DECAL*/);

#ifdef PALETTED_TEXTURE
	if ((g_bPaletteTexture)&&(!p_stGLTextures[iNbGLTextures-1].a_stSubTex[0].bIsNZ))
	{	glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, p_stGLTextures[iNbGLTextures-1].iWidth, p_stGLTextures[iNbGLTextures-1].iHeight, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_stGLTextures[iNbGLTextures-1].p_bRGBBuffer);
	}
	else
#endif
	{	glTexImage2D(GL_TEXTURE_2D, 0, 4, p_stGLTextures[iNbGLTextures-1].iWidth, p_stGLTextures[iNbGLTextures-1].iHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, p_stGLTextures[iNbGLTextures-1].p_bRGBBuffer);
	}
	return iTex;
}

// MR0309
GLint fn_iIsFlatTextureRegistered(int iTexNum)
{ int i;

	for (i=0;i<iNbTexturesInMap;i++)
	{
		if (p_stGLTexArray[i].iFlatID==iTexNum)
			return i;
	}
	return -1;
}

GLint GL_vRegisterFlatTextureOnTheFly(int iTexNum)
{ texture_t	*texture;
  GLint iTex;

	if ((iTex=fn_iIsFlatTextureRegistered(iTexNum))!=-1)
		return iTex;
	texture=textures[iTexNum];
	fn_vRegisterFlatTexture(iTexNum);
	iTex=iNbGLTextures-1;

	texobjs=(GLuint *)glRealloc(texobjs,iNbGLTextures*sizeof(GLuint));
	//texobjs[iNbGLTextures-1] = iNbGLTextures;
	glGenTextures(1,texobjs+iNbGLTextures-1);

	glBindTexture(GL_TEXTURE_2D, texobjs[iNbGLTextures-1]);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE /*GL_DECAL*/);

#ifdef PALETTED_TEXTURE
	if ((g_bPaletteTexture)&&(!p_stGLTextures[iNbGLTextures-1].a_stSubTex[0].bIsNZ))
	{	glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, p_stGLTextures[iNbGLTextures-1].iWidth, p_stGLTextures[iNbGLTextures-1].iHeight, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_stGLTextures[iNbGLTextures-1].p_bRGBBuffer);
	}
	else
#endif
	{	glTexImage2D(GL_TEXTURE_2D, 0, 4, p_stGLTextures[iNbGLTextures-1].iWidth, p_stGLTextures[iNbGLTextures-1].iHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, p_stGLTextures[iNbGLTextures-1].p_bRGBBuffer);
	}
	return iTex;
}

#endif // ZDOOM_GL
